diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
index 7d2cbd2c..d0a53e37 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
@@ -25,6 +25,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.scrambling.ScrambleState;
@@ -306,9 +307,9 @@ public class TwistySquare2 extends TwistySquare
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.SQU2_3.ordinal();
+    return new ObjectSignature(ObjectType.SQU2_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyStarminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyStarminx.java
index cedbfdd2..21d7b46a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyStarminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyStarminx.java
@@ -24,6 +24,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 import java.io.InputStream;
@@ -374,9 +375,9 @@ public class TwistyStarminx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.STAR_3.ordinal();
+    return new ObjectSignature(ObjectType.STAR_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java b/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
index a526a607..d1047aae 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyTrajber.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeOctahedron;
@@ -611,10 +612,17 @@ public class TwistyTrajber extends ShapeOctahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     int[] numLayers = getNumLayers();
-    return numLayers[0]==3 ? ObjectType.TRAJ_3.ordinal() : ObjectType.TRAJ_4.ordinal();
+
+    switch(numLayers[0])
+      {
+      case 3: return new ObjectSignature(ObjectType.TRAJ_3);
+      case 4: return new ObjectSignature(ObjectType.TRAJ_4);
+      }
+
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -622,7 +630,14 @@ public class TwistyTrajber extends ShapeOctahedron
   public String getObjectName()
     {
     int[] numLayers = getNumLayers();
-    return numLayers[0]==3 ? "Trajber's Octahedron" : "Trajber 4x4";
+
+    switch(numLayers[0])
+      {
+      case 3: return "Trajber's Octahedron";
+      case 4: return "Trajber 4x4";
+      }
+
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -630,7 +645,14 @@ public class TwistyTrajber extends ShapeOctahedron
   public String getInventor()
     {
     int[] numLayers = getNumLayers();
-    return numLayers[0]==3 ? "Josef Trajber" : "Jürgen Brandt";
+
+    switch(numLayers[0])
+      {
+      case 3: return "Josef Trajber";
+      case 4: return "Jürgen Brandt";
+      }
+
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index e2e18363..4d5e7713 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlDodecahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -378,9 +379,9 @@ public class TwistyUltimate extends ShapeDodecahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.ULTI_2.ordinal();
+    return new ObjectSignature(ObjectType.ULTI_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyVoid.java b/src/main/java/org/distorted/objectlib/objects/TwistyVoid.java
index b61c9bc5..09fa0c8c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyVoid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyVoid.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeHexahedron;
@@ -414,9 +415,9 @@ public class TwistyVoid extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.VOID_3.ordinal();
+    return new ObjectSignature(ObjectType.VOID_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyWindmill.java b/src/main/java/org/distorted/objectlib/objects/TwistyWindmill.java
index b1fe35c3..3596f9b4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyWindmill.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyWindmill.java
@@ -26,6 +26,7 @@ import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeHexahedron;
@@ -424,9 +425,9 @@ public class TwistyWindmill extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.WIND_3.ordinal();
+    return new ObjectSignature(ObjectType.WIND_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/scrambling/ObjectScrambler.java b/src/main/java/org/distorted/objectlib/scrambling/ObjectScrambler.java
index fc42691b..920f618c 100644
--- a/src/main/java/org/distorted/objectlib/scrambling/ObjectScrambler.java
+++ b/src/main/java/org/distorted/objectlib/scrambling/ObjectScrambler.java
@@ -22,6 +22,8 @@ package org.distorted.objectlib.scrambling;
 import java.util.ArrayList;
 import java.util.Random;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
 public class ObjectScrambler
@@ -52,8 +54,9 @@ public class ObjectScrambler
   private int[][] mQuatMult;
 
   // type=2 , i.e. locally created bandaged cuboids
-  private static long mSignature;
+  private static ObjectSignature mSignature;
   private ArrayList<ScrambleStateBandagedCuboid> mBandagedStates;
+  private int[] mSize, mTurns;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -70,6 +73,19 @@ public class ObjectScrambler
       mCornerQuat = new int[8];
       mLastRot = LAST_SL;
       }
+    if( mType==2 )
+      {
+      mSize = new int[3];
+      mTurns= new int[3];
+
+      mSize[0] = (mNumLayers[0]>1 ? mNumLayers[0] : 0);
+      mSize[1] = (mNumLayers[1]>1 ? mNumLayers[1] : 0);
+      mSize[2] = (mNumLayers[2]>1 ? mNumLayers[2] : 0);
+
+      mTurns[0] = mNumLayers[1]==mNumLayers[2] ? 3:1;
+      mTurns[1] = mNumLayers[0]==mNumLayers[2] ? 3:1;
+      mTurns[2] = mNumLayers[0]==mNumLayers[1] ? 3:1;
+      }
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -405,6 +421,39 @@ public class ObjectScrambler
       }
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// TYPE 2
+
+  private void fillOutScramble(int[] scramble, int moveIndex)
+    {
+    for(int axis=0; axis<3; axis++)
+      {
+      int size = mTurns[axis]*mSize[axis];
+
+      if( moveIndex<size )
+        {
+        scramble[0] = axis;
+        scramble[1] = moveIndex/mTurns[axis];
+
+        if( mTurns[axis]==3 )
+          {
+          switch(moveIndex%3)
+            {
+            case 0: scramble[2] = -1; break;
+            case 1: scramble[2] =  2; break;
+            case 2: scramble[2] =  1; break;
+            }
+          }
+        else scramble[2] =  1;
+        return;
+        }
+
+      moveIndex -= size;
+      }
+
+    android.util.Log.e("D", "ERROR in fillOutScramble moveIndex="+moveIndex);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // TYPE 2
 
@@ -431,19 +480,10 @@ public class ObjectScrambler
       int randMove = rnd.nextInt(numMoves);
       int moveIndex = currState.getNthMove(randMove,indexExcluded);
       mSignature = currState.getMove(moveIndex);
-
-      scramble[curr][0] = moveIndex/9;
-      scramble[curr][1] = (moveIndex%9)/3;
-
-      switch(moveIndex%3)
-        {
-        case 0: scramble[curr][2] = -1; break;
-        case 1: scramble[curr][2] =  2; break;
-        case 2: scramble[curr][2] =  1; break;
-        }
+      fillOutScramble(scramble[curr],moveIndex);
       }
 
-    ScrambleStateBandagedCuboid nextState = new ScrambleStateBandagedCuboid(mSignature);
+    ScrambleStateBandagedCuboid nextState = new ScrambleStateBandagedCuboid(mNumLayers[0], mNumLayers[1], mNumLayers[2], mSignature);
     mBandagedStates.add(nextState);
     }
 
@@ -462,7 +502,7 @@ public class ObjectScrambler
         {
         mBandagedStates.remove(curr);
         ScrambleStateBandagedCuboid prevState = mBandagedStates.get(curr-1);
-        long signature = currState.getID();
+        ObjectSignature signature = currState.getSignature();
         prevState.removeMoves(signature);
         boolean result = buildMove(scramble,rnd,curr-1);
         if( !result ) return false;
@@ -479,18 +519,9 @@ public class ObjectScrambler
     int randMove = rnd.nextInt(numMoves);
     int moveIndex = currState.getNthMove(randMove,indexExcluded);
     mSignature = currState.getMove(moveIndex);
+    fillOutScramble(scramble[curr],moveIndex);
 
-    scramble[curr][0] = moveIndex/9;
-    scramble[curr][1] = (moveIndex%9)/3;
-
-    switch(moveIndex%3)
-      {
-      case 0: scramble[curr][2] = -1; break;
-      case 1: scramble[curr][2] =  2; break;
-      case 2: scramble[curr][2] =  1; break;
-      }
-
-    ScrambleStateBandagedCuboid nextState = new ScrambleStateBandagedCuboid(mSignature);
+    ScrambleStateBandagedCuboid nextState = new ScrambleStateBandagedCuboid(mNumLayers[0], mNumLayers[1], mNumLayers[2], mSignature);
     mBandagedStates.add(nextState);
 
     return true;
@@ -504,7 +535,7 @@ public class ObjectScrambler
     if( mBandagedStates==null ) mBandagedStates = new ArrayList<>();
     else                        mBandagedStates.clear();
 
-    ScrambleStateBandagedCuboid state = new ScrambleStateBandagedCuboid(mSignature);
+    ScrambleStateBandagedCuboid state = new ScrambleStateBandagedCuboid(mNumLayers[0], mNumLayers[1], mNumLayers[2], mSignature);
     mBandagedStates.add(state);
     boolean success = true;
 
@@ -521,7 +552,7 @@ public class ObjectScrambler
     if( !success )
       {
       mBandagedStates.clear();
-      state = new ScrambleStateBandagedCuboid(mSignature);
+      state = new ScrambleStateBandagedCuboid(mNumLayers[0], mNumLayers[1], mNumLayers[2], mSignature);
       mBandagedStates.add(state);
 
       for(int curr=0; curr<total; curr++)
@@ -529,12 +560,17 @@ public class ObjectScrambler
         buildMoveForced(scramble,rnd,curr);
         }
       }
+
+for(int i=0; i<total; i++)
+  {
+  android.util.Log.e("D", "scramble "+i+" axis: "+scramble[i][0]+" layer="+scramble[i][1]+" angle="+scramble[i][2]);
+  }
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // TYPE 2
 
-  public static void setSignature(long signature)
+  public static void setSignature(ObjectSignature signature)
     {
     mSignature = signature;
     }
